# salt.modules.neutron

Module for handling OpenStack Neutron calls

depends:

  - neutronclient Python module

configuration:

  This module is not usable until the user, password, tenant, and auth URL are specified either in a pillar or in the minion's config file. For example:

      keystone.user: 'admin'
      keystone.password: 'password'
      keystone.tenant: 'admin'
      keystone.auth_url: 'http://127.0.0.1:5000/v2.0/'
      keystone.region_name: 'RegionOne'
      keystone.service_type: 'network'

  If configuration for multiple OpenStack accounts is required, they can be set up as different configuration profiles: For example:

      openstack1:
        keystone.user: 'admin'
        keystone.password: 'password'
        keystone.tenant: 'admin'
        keystone.auth_url: 'http://127.0.0.1:5000/v2.0/'
        keystone.region_name: 'RegionOne'
        keystone.service_type: 'network'

      openstack2:
        keystone.user: 'admin'
        keystone.password: 'password'
        keystone.tenant: 'admin'
        keystone.auth_url: 'http://127.0.0.2:5000/v2.0/'
        keystone.region_name: 'RegionOne'
        keystone.service_type: 'network'

  With this configuration in place, any of the neutron functions can make use of a configuration profile by declaring it explicitly. For example:

      salt '*' neutron.network_list profile=openstack1

  To use keystoneauth1 instead of keystoneclient, include the use_keystoneauth option in the pillar or minion config.

  Note

  this is required to use keystone v3 as for authentication.

      keystone.user: admin
      keystone.password: verybadpass
      keystone.tenant: admin
      keystone.auth_url: 'http://127.0.0.1:5000/v3/'
      keystone.region_name: 'RegionOne'
      keystone.service_type: 'network'
      keystone.use_keystoneauth: true
      keystone.verify: '/path/to/custom/certs/ca-bundle.crt'

  Note: by default the neutron module will attempt to verify its connection utilizing the system certificates. If you need to verify against another bundle of CA certificates or want to skip verification altogether you will need to specify the verify option. You can specify True or False to verify (or not) against system certificates, a path to a bundle or CA certs to check against, or None to allow keystoneauth to search for the certificates on its own.(defaults to True)

salt.modules.neutron.add_gateway_router(router, ext_network, profile=None)

  Adds an external network gateway to the specified router

  CLI Example:

      salt '*' neutron.add_gateway_router router-name ext-network-name

  Parameters:

    - router -- ID or name of the router

    - ext_network -- ID or name of the external network the gateway

    - profile -- Profile to build on (Optional)

  Returns:

    Added Gateway router information

salt.modules.neutron.add_interface_router(router, subnet, profile=None)

  Adds an internal network interface to the specified router

  CLI Example:

      salt '*' neutron.add_interface_router router-name subnet-name

  Parameters:

    - router -- ID or name of the router

    - subnet -- ID or name of the subnet

    - profile -- Profile to build on (Optional)

  Returns:

    Added interface information

salt.modules.neutron.create_firewall_rule(protocol, action, profile=None, **kwargs)

  Creates a new firewall rule

  CLI Example:

      salt '*' neutron.create_firewall_rule protocol action
              tenant_id=TENANT_ID name=NAME description=DESCRIPTION ip_version=IP_VERSION
              source_ip_address=SOURCE_IP_ADDRESS destination_ip_address=DESTINATION_IP_ADDRESS source_port=SOURCE_PORT
              destination_port=DESTINATION_PORT shared=SHARED enabled=ENABLED

  Parameters:

    - protocol -- Protocol for the firewall rule, choose "tcp","udp","icmp" or "None".

    - action -- Action for the firewall rule, choose "allow" or "deny".

    - tenant_id -- The owner tenant ID. (Optional)

    - name -- Name for the firewall rule. (Optional)

    - description -- Description for the firewall rule. (Optional)

    - ip_version -- IP protocol version, default: 4. (Optional)

    - source_ip_address -- Source IP address or subnet. (Optional)

    - destination_ip_address -- Destination IP address or subnet. (Optional)

    - source_port -- Source port (integer in [1, 65535] or range in a:b). (Optional)

    - destination_port -- Destination port (integer in [1, 65535] or range in a:b). (Optional)

    - shared -- Set shared to True, default: False. (Optional)

    - enabled -- To enable this rule, default: True. (Optional)

salt.modules.neutron.create_floatingip(floating_network, port=None, profile=None)

  Creates a new floatingIP

  CLI Example:

      salt '*' neutron.create_floatingip network-name port-name

  Parameters:

    - floating_network -- Network name or ID to allocate floatingIP from

    - port -- Of the port to be associated with the floatingIP (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created floatingIP information

salt.modules.neutron.create_ikepolicy(name, profile=None, **kwargs)

  Creates a new IKEPolicy

  CLI Example:

      salt '*' neutron.create_ikepolicy ikepolicy-name
              phase1_negotiation_mode=main auth_algorithm=sha1
              encryption_algorithm=aes-128 pfs=group5

  Parameters:

    - name -- Name of the IKE policy

    - phase1_negotiation_mode -- IKE Phase1 negotiation mode in lowercase, default: main (Optional)

    - auth_algorithm -- Authentication algorithm in lowercase, default: sha1 (Optional)

    - encryption_algorithm -- Encryption algorithm in lowercase. default:aes-128 (Optional)

    - pfs -- Prefect Forward Security in lowercase, default: group5 (Optional)

    - units -- IKE lifetime attribute. default: seconds (Optional)

    - value -- IKE lifetime attribute. default: 3600 (Optional)

    - ike_version -- IKE version in lowercase, default: v1 (Optional)

    - profile -- Profile to build on (Optional)

    - kwargs

  Returns:

    Created IKE policy information

salt.modules.neutron.create_ipsec_site_connection(name, ipsecpolicy, ikepolicy, vpnservice, peer_cidrs, peer_address, peer_id, psk, admin_state_up=True, profile=None, **kwargs)

  Creates a new IPsecSiteConnection

  CLI Example:

      salt '*' neutron.show_ipsec_site_connection connection-name
              ipsec-policy-name ikepolicy-name vpnservice-name
              192.168.XXX.XXX/24 192.168.XXX.XXX 192.168.XXX.XXX secret

  Parameters:

    - name -- Set friendly name for the connection

    - ipsecpolicy -- IPSec policy ID or name associated with this connection

    - ikepolicy -- IKE policy ID or name associated with this connection

    - vpnservice -- VPN service instance ID or name associated with this connection

    - peer_cidrs -- Remote subnet(s) in CIDR format

    - peer_address -- Peer gateway public IPv4/IPv6 address or FQDN

    - peer_id -- Peer router identity for authentication Can be IPv4/IPv6 address, e-mail address, key id, or FQDN

    - psk -- Pre-shared key string

    - initiator -- Initiator state in lowercase, default:bi-directional

    - admin_state_up -- Set admin state up to true or false, default: True (Optional)

    - mtu -- size for the connection, default:1500 (Optional)

    - dpd_action -- Dead Peer Detection attribute: hold/clear/disabled/ restart/restart-by-peer (Optional)

    - dpd_interval -- Dead Peer Detection attribute (Optional)

    - dpd_timeout -- Dead Peer Detection attribute (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created IPSec site connection information

salt.modules.neutron.create_ipsecpolicy(name, profile=None, **kwargs)

  Creates a new IPsecPolicy

  CLI Example:

      salt '*' neutron.create_ipsecpolicy ipsecpolicy-name
              transform_protocol=esp auth_algorithm=sha1
              encapsulation_mode=tunnel encryption_algorithm=aes-128

  Parameters:

    - name -- Name of the IPSec policy

    - transform_protocol -- Transform protocol in lowercase, default: esp (Optional)

    - auth_algorithm -- Authentication algorithm in lowercase, default: sha1 (Optional)

    - encapsulation_mode -- Encapsulation mode in lowercase, default: tunnel (Optional)

    - encryption_algorithm -- Encryption algorithm in lowercase, default:aes-128 (Optional)

    - pfs -- Prefect Forward Security in lowercase, default: group5 (Optional)

    - units -- IPSec lifetime attribute. default: seconds (Optional)

    - value -- IPSec lifetime attribute. default: 3600 (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created IPSec policy information

salt.modules.neutron.create_network(name, router_ext=None, admin_state_up=True, network_type=None, physical_network=None, segmentation_id=None, shared=None, profile=None)

  Creates a new network

  CLI Example:

      salt '*' neutron.create_network network-name
      salt '*' neutron.create_network network-name profile=openstack1

  Parameters:

    - name -- Name of network to create

    - admin_state_up -- should the state of the network be up? default: True (Optional)

    - router_ext -- True then if create the external network (Optional)

    - network_type -- the Type of network that the provider is such as GRE, VXLAN, VLAN, FLAT, or LOCAL (Optional)

    - physical_network -- the name of the physical network as neutron knows it (Optional)

    - segmentation_id -- the vlan id or GRE id (Optional)

    - shared -- is the network shared or not (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created network information

salt.modules.neutron.create_port(name, network, device_id=None, admin_state_up=True, profile=None)

  Creates a new port

  CLI Example:

      salt '*' neutron.create_port network-name port-name

  Parameters:

    - name -- Name of port to create

    - network -- Network name or ID

    - device_id -- ID of device (Optional)

    - admin_state_up -- Set admin state up to true or false, default: true (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created port information

salt.modules.neutron.create_router(name, ext_network=None, admin_state_up=True, profile=None)

  Creates a new router

  CLI Example:

      salt '*' neutron.create_router new-router-name

  Parameters:

    - name -- Name of router to create (must be first)

    - ext_network -- ID or name of the external for the gateway (Optional)

    - admin_state_up -- Set admin state up to true or false, default:true (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created router information

salt.modules.neutron.create_security_group(name=None, description=None, profile=None)

  Creates a new security group

  CLI Example:

      salt '*' neutron.create_security_group security-group-name                 description='Security group for servers'

  Parameters:

    - name -- Name of security group (Optional)

    - description -- Description of security group (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created security group information

salt.modules.neutron.create_security_group_rule(security_group, remote_group_id=None, direction='ingress', protocol=None, port_range_min=None, port_range_max=None, ethertype='IPv4', profile=None)

  Creates a new security group rule

  CLI Example:

      salt '*' neutron.show_security_group_rule security-group-rule-id

  Parameters:

    - security_group -- Security group name or ID to add rule

    - remote_group_id -- Remote security group name or ID to apply rule (Optional)

    - direction -- Direction of traffic: ingress/egress, default: ingress (Optional)

    - protocol -- Protocol of packet: null/icmp/tcp/udp, default: null (Optional)

    - port_range_min -- Starting port range (Optional)

    - port_range_max -- Ending port range (Optional)

    - ethertype -- IPv4/IPv6, default: IPv4 (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created security group rule information

salt.modules.neutron.create_subnet(network, cidr, name=None, ip_version=4, profile=None)

  Creates a new subnet

  CLI Example:

      salt '*' neutron.create_subnet network-name 192.168.1.0/24

  Parameters:

    - network -- Network ID or name this subnet belongs to

    - cidr -- CIDR of subnet to create (Ex. '192.168.1.0/24')

    - name -- Name of the subnet to create (Optional)

    - ip_version -- Version to use, default is 4(IPv4) (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created subnet information

salt.modules.neutron.create_vpnservice(subnet, router, name, admin_state_up=True, profile=None)

  Creates a new VPN service

  CLI Example:

      salt '*' neutron.create_vpnservice router-name name

  Parameters:

    - subnet -- Subnet unique identifier for the VPN service deployment

    - router -- Router unique identifier for the VPN service

    - name -- Set a name for the VPN service

    - admin_state_up -- Set admin state up to true or false, default:True (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Created VPN service information

salt.modules.neutron.delete_firewall_rule(firewall_rule, profile=None)

  Deletes the specified firewall_rule

  CLI Example:

      salt '*' neutron.delete_firewall_rule firewall-rule

  Parameters:

    - firewall_rule -- ID or name of firewall rule to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_floatingip(floatingip_id, profile=None)

  Deletes the specified floating IP

  CLI Example:

      salt '*' neutron.delete_floatingip floatingip-id

  Parameters:

    - floatingip_id -- ID of floatingIP to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_ikepolicy(ikepolicy, profile=None)

  Deletes the specified IKEPolicy

  CLI Example:

      salt '*' neutron.delete_ikepolicy ikepolicy-name

  Parameters:

    - ikepolicy -- ID or name of IKE policy to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_ipsec_site_connection(ipsec_site_connection, profile=None)

  Deletes the specified IPsecSiteConnection

  CLI Example:

      salt '*' neutron.delete_ipsec_site_connection connection-name

  Parameters:

    - ipsec_site_connection -- ID or name of ipsec site connection to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_ipsecpolicy(ipsecpolicy, profile=None)

  Deletes the specified IPsecPolicy

  CLI Example:

      salt '*' neutron.delete_ipsecpolicy ipsecpolicy-name

  Parameters:

    - ipsecpolicy -- ID or name of IPSec policy to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_network(network, profile=None)

  Deletes the specified network

  CLI Example:

      salt '*' neutron.delete_network network-name
      salt '*' neutron.delete_network network-name profile=openstack1

  Parameters:

    - network -- ID or name of network to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_port(port, profile=None)

  Deletes the specified port

  CLI Example:

      salt '*' neutron.delete_network port-name
      salt '*' neutron.delete_network port-name profile=openstack1

  Parameters:

    - port -- port name or ID

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_quota(tenant_id, profile=None)

  Delete the specified tenant's quota value

  CLI Example:

      salt '*' neutron.update_quota tenant-id
      salt '*' neutron.update_quota tenant-id profile=openstack1

  Parameters:

    - tenant_id -- ID of tenant to quota delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Delete succeed) or False(Delete failed)

salt.modules.neutron.delete_router(router, profile=None)

  Delete the specified router

  CLI Example:

      salt '*' neutron.delete_router router-name

  Parameters:

    - router -- ID or name of router to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_security_group(security_group, profile=None)

  Deletes the specified security group

  CLI Example:

      salt '*' neutron.delete_security_group security-group-name

  Parameters:

    - security_group -- ID or name of security group to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_security_group_rule(security_group_rule_id, profile=None)

  Deletes the specified security group rule

  CLI Example:

      salt '*' neutron.delete_security_group_rule security-group-rule-id

  Parameters:

    - security_group_rule_id -- ID of security group rule to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_subnet(subnet, profile=None)

  Deletes the specified subnet

  CLI Example:

      salt '*' neutron.delete_subnet subnet-name
      salt '*' neutron.delete_subnet subnet-name profile=openstack1

  Parameters:

    - subnet -- ID or name of subnet to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.delete_vpnservice(vpnservice, profile=None)

  Deletes the specified VPN service

  CLI Example:

      salt '*' neutron.delete_vpnservice vpnservice-name

  Parameters:

    - vpnservice -- ID or name of vpn service to delete

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.get_quotas_tenant(profile=None)

  Fetches tenant info in server's context for following quota operation

  CLI Example:

      salt '*' neutron.get_quotas_tenant
      salt '*' neutron.get_quotas_tenant profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    Quotas information

salt.modules.neutron.list_agents(profile=None)

  List agents.

  CLI Example:

      salt '*' neutron.list_agents

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    agents message.

salt.modules.neutron.list_extensions(profile=None)

  Fetches a list of all extensions on server side

  CLI Example:

      salt '*' neutron.list_extensions
      salt '*' neutron.list_extensions profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of extensions

salt.modules.neutron.list_firewall_rules(profile=None)

  Fetches a list of all firewall rules for a tenant

  CLI Example:

      salt '*' neutron.list_firewall_rules

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of firewall rules

salt.modules.neutron.list_firewalls(profile=None)

  Fetches a list of all firewalls for a tenant

  CLI Example:

      salt '*' neutron.list_firewalls

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of firewalls

salt.modules.neutron.list_floatingips(profile=None)

  Fetch a list of all floatingIPs for a tenant

  CLI Example:

      salt '*' neutron.list_floatingips
      salt '*' neutron.list_floatingips profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of floatingIP

salt.modules.neutron.list_ikepolicies(profile=None)

  Fetches a list of all configured IKEPolicies for a tenant

  CLI Example:

      salt '*' neutron.list_ikepolicies
      salt '*' neutron.list_ikepolicies profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of IKE policy

salt.modules.neutron.list_ipsec_site_connections(profile=None)

  Fetches all configured IPsec Site Connections for a tenant

  CLI Example:

      salt '*' neutron.list_ipsec_site_connections
      salt '*' neutron.list_ipsec_site_connections profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of IPSec site connection

salt.modules.neutron.list_ipsecpolicies(profile=None)

  Fetches a list of all configured IPsecPolicies for a tenant

  CLI Example:

      salt '*' neutron.list_ipsecpolicies ipsecpolicy-name
      salt '*' neutron.list_ipsecpolicies ipsecpolicy-name profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of IPSec policy

salt.modules.neutron.list_l3_agent_hosting_routers(router, profile=None)

  List L3 agents hosting a router.

  CLI Example:

      salt '*' neutron.list_l3_agent_hosting_routers router

  :param router:router name or ID to query. :param profile: Profile to build on (Optional) :return: L3 agents message.

salt.modules.neutron.list_networks(profile=None)

  Fetches a list of all networks for a tenant

  CLI Example:

      salt '*' neutron.list_networks
      salt '*' neutron.list_networks profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of network

salt.modules.neutron.list_ports(profile=None)

  Fetches a list of all networks for a tenant

  CLI Example:

      salt '*' neutron.list_ports
      salt '*' neutron.list_ports profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of port

salt.modules.neutron.list_quotas(profile=None)

  Fetches all tenants quotas

  CLI Example:

      salt '*' neutron.list_quotas
      salt '*' neutron.list_quotas profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of quotas

salt.modules.neutron.list_routers(profile=None)

  Fetches a list of all routers for a tenant

  CLI Example:

      salt '*' neutron.list_routers
      salt '*' neutron.list_routers profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of router

salt.modules.neutron.list_security_group_rules(profile=None)

  Fetches a list of all security group rules for a tenant

  CLI Example:

      salt '*' neutron.list_security_group_rules
      salt '*' neutron.list_security_group_rules profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of security group rule

salt.modules.neutron.list_security_groups(profile=None)

  Fetches a list of all security groups for a tenant

  CLI Example:

      salt '*' neutron.list_security_groups
      salt '*' neutron.list_security_groups profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of security group

salt.modules.neutron.list_subnets(profile=None)

  Fetches a list of all networks for a tenant

  CLI Example:

      salt '*' neutron.list_subnets
      salt '*' neutron.list_subnets profile=openstack1

  Parameters:

    profile -- Profile to build on (Optional)

  Returns:

    List of subnet

salt.modules.neutron.list_vpnservices(retrieve_all=True, profile=None, **kwargs)

  Fetches a list of all configured VPN services for a tenant

  CLI Example:

      salt '*' neutron.list_vpnservices

  Parameters:

    - retrieve_all -- True or False, default: True (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    List of VPN service

salt.modules.neutron.remove_gateway_router(router, profile=None)

  Removes an external network gateway from the specified router

  CLI Example:

      salt '*' neutron.remove_gateway_router router-name

  Parameters:

    - router -- ID or name of router

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.remove_interface_router(router, subnet, profile=None)

  Removes an internal network interface from the specified router

  CLI Example:

      salt '*' neutron.remove_interface_router router-name subnet-name

  Parameters:

    - router -- ID or name of the router

    - subnet -- ID or name of the subnet

    - profile -- Profile to build on (Optional)

  Returns:

    True(Succeed) or False

salt.modules.neutron.show_firewall(firewall, profile=None)

  Fetches information of a specific firewall rule

  CLI Example:

      salt '*' neutron.show_firewall firewall

  Parameters:

    - firewall -- ID or name of firewall to look up

    - profile -- Profile to build on (Optional)

  Returns:

    firewall information

salt.modules.neutron.show_firewall_rule(firewall_rule, profile=None)

  Fetches information of a specific firewall rule

  CLI Example:

      salt '*' neutron.show_firewall_rule firewall-rule-name

  Parameters:

    - ipsecpolicy -- ID or name of firewall rule to look up

    - profile -- Profile to build on (Optional)

  Returns:

    firewall rule information

salt.modules.neutron.show_floatingip(floatingip_id, profile=None)

  Fetches information of a certain floatingIP

  CLI Example:

      salt '*' neutron.show_floatingip floatingip-id

  Parameters:

    - floatingip_id -- ID of floatingIP to look up

    - profile -- Profile to build on (Optional)

  Returns:

    Floating IP information

salt.modules.neutron.show_ikepolicy(ikepolicy, profile=None)

  Fetches information of a specific IKEPolicy

  CLI Example:

      salt '*' neutron.show_ikepolicy ikepolicy-name

  Parameters:

    - ikepolicy -- ID or name of ikepolicy to look up

    - profile -- Profile to build on (Optional)

  Returns:

    IKE policy information

salt.modules.neutron.show_ipsec_site_connection(ipsec_site_connection, profile=None)

  Fetches information of a specific IPsecSiteConnection

  CLI Example:

      salt '*' neutron.show_ipsec_site_connection connection-name

  Parameters:

    - ipsec_site_connection -- ID or name of ipsec site connection to look up

    - profile -- Profile to build on (Optional)

  Returns:

    IPSec site connection information

salt.modules.neutron.show_ipsecpolicy(ipsecpolicy, profile=None)

  Fetches information of a specific IPsecPolicy

  CLI Example:

      salt '*' neutron.show_ipsecpolicy ipsecpolicy-name

  Parameters:

    - ipsecpolicy -- ID or name of IPSec policy to look up

    - profile -- Profile to build on (Optional)

  Returns:

    IPSec policy information

salt.modules.neutron.show_network(network, profile=None)

  Fetches information of a certain network

  CLI Example:

      salt '*' neutron.show_network network-name
      salt '*' neutron.show_network network-name profile=openstack1

  Parameters:

    - network -- ID or name of network to look up

    - profile -- Profile to build on (Optional)

  Returns:

    Network information

salt.modules.neutron.show_port(port, profile=None)

  Fetches information of a certain port

  CLI Example:

      salt '*' neutron.show_port port-id
      salt '*' neutron.show_port port-id profile=openstack1

  Parameters:

    - port -- ID or name of port to look up

    - profile -- Profile to build on (Optional)

  Returns:

    Port information

salt.modules.neutron.show_quota(tenant_id, profile=None)

  Fetches information of a certain tenant's quotas

  CLI Example:

      salt '*' neutron.show_quota tenant-id
      salt '*' neutron.show_quota tenant-id profile=openstack1

  Parameters:

    - tenant_id -- ID of tenant

    - profile -- Profile to build on (Optional)

  Returns:

    Quota information

salt.modules.neutron.show_router(router, profile=None)

  Fetches information of a certain router

  CLI Example:

      salt '*' neutron.show_router router-name

  Parameters:

    - router -- ID or name of router to look up

    - profile -- Profile to build on (Optional)

  Returns:

    Router information

salt.modules.neutron.show_security_group(security_group, profile=None)

  Fetches information of a certain security group

  CLI Example:

      salt '*' neutron.show_security_group security-group-name

  Parameters:

    - security_group -- ID or name of security group to look up

    - profile -- Profile to build on (Optional)

  Returns:

    Security group information

salt.modules.neutron.show_security_group_rule(security_group_rule_id, profile=None)

  Fetches information of a certain security group rule

  CLI Example:

      salt '*' neutron.show_security_group_rule security-group-rule-id

  Parameters:

    - security_group_rule_id -- ID of security group rule to look up

    - profile -- Profile to build on (Optional)

  Returns:

    Security group rule information

salt.modules.neutron.show_subnet(subnet, profile=None)

  Fetches information of a certain subnet

  CLI Example:

      salt '*' neutron.show_subnet subnet-name

  Parameters:

    - subnet -- ID or name of subnet to look up

    - profile -- Profile to build on (Optional)

  Returns:

    Subnet information

salt.modules.neutron.show_vpnservice(vpnservice, profile=None, **kwargs)

  Fetches information of a specific VPN service

  CLI Example:

      salt '*' neutron.show_vpnservice vpnservice-name

  Parameters:

    - vpnservice -- ID or name of vpn service to look up

    - profile -- Profile to build on (Optional)

  Returns:

    VPN service information

salt.modules.neutron.update_firewall_rule(firewall_rule, protocol=None, action=None, name=None, description=None, ip_version=None, source_ip_address=None, destination_ip_address=None, source_port=None, destination_port=None, shared=None, enabled=None, profile=None)

  Update a firewall rule

  CLI Example:

      salt '*' neutron.update_firewall_rule firewall_rule protocol=PROTOCOL action=ACTION
              name=NAME description=DESCRIPTION ip_version=IP_VERSION
              source_ip_address=SOURCE_IP_ADDRESS destination_ip_address=DESTINATION_IP_ADDRESS
              source_port=SOURCE_PORT destination_port=DESTINATION_PORT shared=SHARED enabled=ENABLED

  Parameters:

    - firewall_rule -- ID or name of firewall rule to update.

    - protocol -- Protocol for the firewall rule, choose "tcp","udp","icmp" or "None". (Optional)

    - action -- Action for the firewall rule, choose "allow" or "deny". (Optional)

    - name -- Name for the firewall rule. (Optional)

    - description -- Description for the firewall rule. (Optional)

    - ip_version -- IP protocol version, default: 4. (Optional)

    - source_ip_address -- Source IP address or subnet. (Optional)

    - destination_ip_address -- Destination IP address or subnet. (Optional)

    - source_port -- Source port (integer in [1, 65535] or range in a:b). (Optional)

    - destination_port -- Destination port (integer in [1, 65535] or range in a:b). (Optional)

    - shared -- Set shared to True, default: False. (Optional)

    - enabled -- To enable this rule, default: True. (Optional)

    - profile -- Profile to build on (Optional)

salt.modules.neutron.update_floatingip(floatingip_id, port=None, profile=None)

  Updates a floatingIP

  CLI Example:

      salt '*' neutron.update_floatingip network-name port-name

  Parameters:

    - floatingip_id -- ID of floatingIP

    - port -- ID or name of port, to associate floatingip to None or do not specify to disassociate the floatingip (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Value of updated floating IP information

salt.modules.neutron.update_network(network, name, profile=None)

  Updates a network

  CLI Example:

      salt '*' neutron.update_network network-name new-network-name

  Parameters:

    - network -- ID or name of network to update

    - name -- Name of this network

    - profile -- Profile to build on (Optional)

  Returns:

    Value of updated network information

salt.modules.neutron.update_port(port, name, admin_state_up=True, profile=None)

  Updates a port

  CLI Example:

      salt '*' neutron.update_port port-name network-name new-port-name

  Parameters:

    - port -- Port name or ID

    - name -- Name of this port

    - admin_state_up -- Set admin state up to true or false, default: true (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Value of updated port information

salt.modules.neutron.update_quota(tenant_id, subnet=None, router=None, network=None, floatingip=None, port=None, security_group=None, security_group_rule=None, profile=None)

  Update a tenant's quota

  CLI Example:

      salt '*' neutron.update_quota tenant-id subnet=40 router=50
                                  network=10 floatingip=30 port=30

  Parameters:

    - tenant_id -- ID of tenant

    - subnet -- Value of subnet quota (Optional)

    - router -- Value of router quota (Optional)

    - network -- Value of network quota (Optional)

    - floatingip -- Value of floatingip quota (Optional)

    - port -- Value of port quota (Optional)

    - security_group -- Value of security group (Optional)

    - security_group_rule -- Value of security group rule (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Value of updated quota

salt.modules.neutron.update_router(router, name=None, admin_state_up=None, profile=None, **kwargs)

  Updates a router

  CLI Example:

      salt '*' neutron.update_router router_id name=new-router-name
              admin_state_up=True

  Parameters:

    - router -- ID or name of router to update

    - name -- Name of this router

    - ext_network -- ID or name of the external for the gateway (Optional)

    - admin_state_up -- Set admin state up to true or false, default: true (Optional)

    - profile -- Profile to build on (Optional)

    - kwargs

  Returns:

    Value of updated router information

salt.modules.neutron.update_security_group(security_group, name=None, description=None, profile=None)

  Updates a security group

  CLI Example:

      salt '*' neutron.update_security_group security-group-name                 new-security-group-name

  Parameters:

    - security_group -- ID or name of security group to update

    - name -- Name of this security group (Optional)

    - description -- Description of security group (Optional)

    - profile -- Profile to build on (Optional)

  Returns:

    Value of updated security group information

salt.modules.neutron.update_subnet(subnet, name, profile=None)

  Updates a subnet

  CLI Example:

      salt '*' neutron.update_subnet subnet-name new-subnet-name

  Parameters:

    - subnet -- ID or name of subnet to update

    - name -- Name of this subnet

    - profile -- Profile to build on (Optional)

  Returns:

    Value of updated subnet information

salt.modules.neutron.update_vpnservice(vpnservice, desc, profile=None)

  Updates a VPN service

  CLI Example:

      salt '*' neutron.update_vpnservice vpnservice-name desc='VPN Service1'

  Parameters:

    - vpnservice -- ID or name of vpn service to update

    - desc -- Set a description for the VPN service

    - profile -- Profile to build on (Optional)

  Returns:

    Value of updated VPN service information